#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int MAXN=1e2;

int a[MAXN];
bool ans[MAXN][MAXN];

bool GetAns(int l, int r)
{
    if(l>=r)
    {
        return false;
    }

    vector<int> v, pr, aft;
    for(int i=l; i<=r; i++)
    {
        v.push_back(a[i]);
    }
    sort(v.begin(), v.end());

    int n=r-l+1;

    pr.push_back(v[0]);
    for(int i=1; i<n; i++)
    {
        pr.push_back(pr.back()|v[i]);
    }

    aft.push_back(v[n-1]);
    for(int i=n-2; i>=0; i--)
    {
        aft.push_back(aft.back()&v[i]);
    }
    reverse(aft.begin(), aft.end());

    for(int i=0; i<n-1; i++)
    {
        if(pr[i]==aft[i+1])
        {
            return true;
        }
    }

    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    for(int i=0; i<n; i++)
    {
        cin >> a[i];
    }

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            ans[i][j]=GetAns(i, j);
        }
    }

    while(q--)
    {
        int l, r;
        cin >> l >> r;
        l--, r--;

        if(ans[l][r])
        {
            cout << "Yes\n";
        }
        else
        {
            cout << "No\n";
        }
    }

    return 0;
}
